#include <stdio.h>
#include <stdlib.h>
unsigned long bp_entry;

struct XENLOADER_BP_ARGS {
	unsigned long base_pa;
	unsigned long base_va;
	unsigned long xen_printk;
} bp_args;

int kcode()
{
	int (*proc)(unsigned long)=(int(*)(unsigned long))bp_entry;
	return proc((unsigned long)&bp_args);
}

main(int argc, char **argv)
{
	char *tmp;
	unsigned int ret;
	if (argc != 5) {
		fprintf(stderr, "%s: <bp_entry> <bp_base_va> <bp_base_pa> <xen_pritnk_addr>\n", argv[0]);
		exit(1);
	}
	fprintf (stderr, "&bp_args = %#x\n", (unsigned long)&bp_args);
	bp_entry = strtoul(argv[1], 0, 0);
	bp_args.base_va = strtoul(argv[2], 0, 0);
	bp_args.base_pa = strtoul(argv[3], 0, 0);
	bp_args.xen_printk = strtoul(argv[4], 0, 0);
	return run0(kcode);
}
